// coded by Jeffrey Jestes
// jestes@cs.fsu.edu

/* prepare 2-grams for any DB file prepared as
   int, int, string\r\n
   needed to create similiarity set in relational database efficiently
*/

#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>
#include "prob_string.h"

using namespace std;


double abs( double a  ) {
   if( a < 0 ) return -a;
   return a;
}

int main( int argc, char** argv ) {

   int start_id = atoi( argv[1] );
   int end_id = atoi( argv[2] );

   char delim = '|';

   long id = 0;
   long new_id = 1;
   vector<char> name;
   vector< vector<char> > grams;
   prob_string x;
   string s;

   while( cin >> id ) {
      name.clear();
      grams.clear();

//      char comma;
//      cin >> comma;


//      int temp;
//      cin >> temp;
//      cin >> comma;

/*
      getline( cin, s, ' ' );
      for( unsigned int i = 0; i < s.size(); ++i ) {
         name.push_back( s[i] );
      }
      getline( cin, s, '\n' );
*/


      getchar();
      getline( cin, s, '\n' );
      for( unsigned int i = 0; i < s.size(); ++i ) {
         if( s[i] == '\r' || s[i] == '\n' ) break;
         if( s[i] < 32 || s[i] > 126 ) name.push_back( '?' );
         else name.push_back( s[i] );
      }

      if( id < start_id ) continue;

//      if( id == 10363 || id == 10364 || id == 133196 ) continue;
      cout << new_id++ << delim << name.size() << delim;
      for( unsigned int i = 0; i < name.size(); ++i ) {
         cout << name[i];
      }
      cout << "\r\n";

      x.QGRAMS( name, grams );
      for( unsigned int i = 0; i < grams.size(); ++i ) {
         cerr << new_id - 1 << delim << i << delim;
         for( unsigned int j = 0; j < grams[i].size(); ++j ) {
            cerr << grams[i][j];
         }
         cerr << delim << name.size() << "\r\n";
      }
      if( id == end_id ) return 0;

   }

   return 0;
}
