public ref class instance {
   public:
      char c;
      double prob;
      instance() {
         c = 0;
         prob = 0;
      }
      instance( char c, double prob ) {
         this->c = c;
         this->prob = prob;
      }
	  instance( const instance^ i ) {
		  this->c = i->c;
		  this->prob = i->prob;
	  }

	  instance^ operator=( const instance^ i ) {
		  this->c = i->c;
		  this->prob = i->prob;

		  return this;
	  }
};


public ref class random_var {
   public:
      List<instance^>^ v;
      random_var() {
         v = gcnew List<instance^>();
      };
      random_var( char c ) {
		  v = gcnew List<instance^>();
         v->Add( gcnew instance( c, 1 ) );
      }
	  random_var( const random_var^ r ) {
		  v = gcnew List<instance^>();
		  for( int i = 0; i < r->v->Count; ++i ) {
			  v->Add( gcnew instance( r->v[i] ) );
		  }
	  }
      ~random_var() {
		  this->v->Clear();
      }

	  void push_back( char c, double p ) {
		  v->Add( gcnew instance( c, p ) );
	  }

      bool contains( char c ) {
         for( int i = 0; i < v->Count; ++i ) {
            if( v[i]->c == c ) return true;
         }
         return false;
      }

      random_var^ operator=( const random_var^ r ) {
         this->v->Clear();
         for( int i = 0; i < r->v->Count; ++i ) {
			 this->v->Add( gcnew instance( r->v[i] ) );
         }
         return this;
      }
};

public ref class prob_string {
   public:
	   List<random_var^>^ ps;
      prob_string() {
		  ps = gcnew List<random_var^>();
	  }
      prob_string( char c ) {
		  ps = gcnew List<random_var^>();
         ps->Add( gcnew random_var( c ) );
      }
      prob_string( prob_string^ p ) {
		  ps = gcnew List<random_var^>();
		  for( int i = 0; i < p->ps->Count; ++i ) {
			  ps->Add( gcnew random_var( p->ps[i] ) );
		  }
      }
      prob_string^ operator=( const prob_string^ p ) {
		  ps->Clear();
		  for( int i = 0; i < p->ps->Count; ++i ) {
			  ps->Add( gcnew random_var( p->ps[i] ) );
		  }

		 return this;
      }

	  void push_back( random_var^ r ) {
		  ps->Add( gcnew random_var( r ) );
	  }

	  prob_string^ to_prob_string( SqlTypes::SqlString s ) {
		  String^ ss = gcnew String(s.ToString());

		  prob_string^ result = gcnew prob_string();
		  random_var^ temp = gcnew random_var();
		  bool no_prob = false;
		  double d = 0;
		  int count = 1;
		  char c = 0;
		  for( int i = 0; i < ss->Length; ) {
			  if( ss[i] == '|' ) {
				  if( no_prob == true ) {
					  temp->push_back( c, 1 );
				  }
				  count = 1;
				  d = 0;
				  c = 0;
				  result->push_back( temp );
				  temp = gcnew random_var();
				  ++i;
			  }
			  else if( ss[i] == '$' ) {
				  no_prob = false;
				  i += 3; // $0.
				  while( i < ss->Length ) {
					  if( ss[i] == '$' ) {
						  d /= count;
						  temp->push_back( c, d );
						  d = 0;
						  count = 1;
						  ++i;
						  break;
					  }
					  else {
						  d *= 10;
						  d += (ss[i] - '0');
						  count *= 10;
						  ++i;
					  }
				  }
			  }
			  else {
				  c = ss[i];
				  no_prob = true;
				  ++i;
			  }
		  }
		  return result;
	  }

      void clear() {
         ps->Clear();
      }

	  void enumerate( List< List<char>^ >^ worlds, List<double>^ prob ) {
		  worlds = gcnew List< List<char>^ >();
		  worlds->Add( gcnew List<char>() );
		  prob = gcnew List<double>();
		  prob->Add(1);

		  int orig_size = 0;

		  for( int i = 0; i < ps->Count; ++i ) {

             if( ps[i]->v->Count == 1 ) {
				 for( int j = 0; j < worlds->Count; ++j ) {
					 worlds[j]->Add( ps[i]->v[0]->c );
                   prob[j] *= ps[i]->v[0]->prob;
                }
             }
             else if( ps[i]->v->Count > 1 ) {
                orig_size = worlds->Count;
                
                // copy the original worlds by the number of choices in the current random var
                for( int j = 0; j < orig_size; ++j ) {
                   for( int k = 0; k < ps[i]->v->Count - 1; ++k ) {
					   List<char>^ temp = gcnew List<char>();
					   for( int l = 0; l < worlds[j]->Count; ++l ) {
						   temp->Add( worlds[j][l] );
					   }
					   worlds->Add( temp );
                      prob->Add( prob[j] );
                   }
                }

                for( int j = 0; j < orig_size; ++j ) {
                   worlds[j]->Add( ps[i]->v[0]->c );
                   prob[j] *= ps[i]->v[0]->prob;
                }
                for( int j = orig_size; j < worlds->Count; ) {
                   for( int k = 1; k < ps[i]->v->Count; ++k, ++j ) {
                      worlds[j]->Add( ps[i]->v[k]->c );
                      prob[j] *= ps[i]->v[k]->prob;
                   }
                }
             } // end else
          } // end for
       } // end enumerate

  
             
};
           
