// coded by Jeffrey Jestes
// jestes@cs.fsu.edu

/* prepare 2-grams for any DB file prepared as
   int, int, string\r\n
   for creating similarity set
*/

#include <iostream>
#include <vector>
#include <string>
#include <stdlib.h>
#include <math.h>
#include "prob_string.h"

using namespace std;


double abs( double a  ) {
   if( a < 0 ) return -a;
   return a;
}

int main() {
   srand( time( 0 ) );
   double r = ( 500000 / 3369984 ) * 100;

   char delim = '|';

   long id = 0;
   long new_id = 1;
   vector<char> name;
   vector< vector<char> > grams;
   prob_string x;
   string s;

   while( cin >> id ) {
      name.clear();
      grams.clear();

      char comma;
      cin >> comma;


      int temp;
      cin >> temp;
      cin >> comma;


      getline( cin, s, '\n' );
      if( rand() % 3369984 > 500000 ) continue;


      for( unsigned int i = 0; i < s.size(); ++i ) {
         if( s[i] == '\r' || s[i] == '\n' || ( s[i] == ' '  && s[i+1] == ' ' ) ) break;
         name.push_back( s[i] );
      }

      cout << new_id << delim << name.size() << delim;
      for( unsigned int i = 0; i < name.size(); ++i ) {
         cout << name[i];
      }
      cout << "\r\n";


      x.QGRAMS( name, grams );
      for( unsigned int i = 0; i < grams.size(); ++i ) {
         cerr << new_id << delim << i << delim;
         for( unsigned int j = 0; j < grams[i].size(); ++j ) {
            cerr << grams[i][j];
         }
         cerr << delim << name.size() << "\r\n";
      }
      new_id++;

   }

   return 0;
}
